package com.redhat.thermostat.tools.eclipse.plugin.tests.model;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

public class PropertyChangeRecorder implements PropertyChangeListener {

    private boolean invoked = false;
    private Object source;
    private String propertyName;
    private Object oldValue;
    private Object newValue;

    public boolean getInvoked() {
        return invoked;
    }

    public Object getSource() {
        return source;
    }

    public String getPropertyName() {
        return propertyName;
    }

    public Object getOldValue() {
        return oldValue;
    }

    public Object getNewValue() {
        return newValue;
    }

    @Override
    public void propertyChange(PropertyChangeEvent evt) {
        invoked = true;

        source = evt.getSource();
        propertyName = evt.getPropertyName();
        oldValue = evt.getOldValue();
        newValue = evt.getNewValue();
    }

    public static void assertPropertyChanged(PropertyChangeRecorder recorder,
            Object source, String propertyName, Object oldValue, Object newValue) {

        assertTrue(recorder.getInvoked());
        assertEquals(source, recorder.getSource());
        assertEquals(propertyName, recorder.getPropertyName());
        assertEquals(oldValue, recorder.getOldValue());
        assertEquals(newValue, recorder.getNewValue());
    }
}
